// START OF CONFIGURATION \\

const brakedisclocation = { //brakediscs array for every car
  "removeMe": {x: 0.0, s: 0.5},
  "example2": {x: 0.02, s: 0.4}
};
const devMode = false;

// END OF CONFIGURATION \\

let brakediscs = [];
var enabled = true;
if(devMode) {
  var command_x = 0.0;
  var command_s = 0.5;
  emit("chat:addSuggestion", "/discs <br>[reset|done|x|size]");
  RegisterCommand("discs", function(source, args) {
    brakediscs_permanent = true;
    switch(args[0]) {
      case "reset":
        command_x = 0.0;
        command_s = 0.5;
        break;
      case "done":
        console.log("\n" + GetDisplayNameFromVehicleModel(GetEntityModel(GetVehiclePedIsIn(GetPlayerPed(-1), false))) + "\nX: " + command_x + "\nSize: " + command_s + "\n");
        command_x = 0.0;
        command_s = 0.5;
        brakediscs_permanent = false;
        break;
      case "x":
        if(args[1] == "+") {
          command_x = command_x + 0.02;
        } else if(args[1] == "-") {
          command_x = command_x - 0.02;
        }
        break;
      case "size":
        if(args[1] == "+") {
          command_s = command_s + 0.02;
        } else if(args[1] == "-") {
          command_s = command_s - 0.02;
        }
        break;
    }
  }, false);
}

RegisterCommand("brakediscs", function() {
  if(enabled) {
    enabled = false;
  } else {
    enabled = true;
    discs();
  }
}, false);

RequestNamedPtfxAsset("core");
function discs() {
  if(HasNamedPtfxAssetLoaded("core")) {
    closeVehicles(function(closeVehiclesArray) {
      closeVehiclesArray.forEach(function(closeVehicle) {
        if(devMode) {
          UseParticleFxAssetNextCall("core");
          let brakedisc1 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, command_x, 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_lf"), command_s, false, false, false);
          StopParticleFxLooped(brakedisc1, false);
          RemoveParticleFx(brakedisc1, true);
          delete brakedisc1;
          UseParticleFxAssetNextCall("core");
          let brakedisc2 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, command_x, 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_rf"), command_s, false, false, false);
          StopParticleFxLooped(brakedisc2, false);
          RemoveParticleFx(brakedisc2, true);
          delete brakedisc2;
          UseParticleFxAssetNextCall("core");
          let brakedisc3 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, command_x, 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_lr"), command_s, false, false, false);
          StopParticleFxLooped(brakedisc3, false);
          RemoveParticleFx(brakedisc3, true);
          delete brakedisc3;
          UseParticleFxAssetNextCall("core");
          let brakedisc4 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, command_x, 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_rr"), command_s, false, false, false);
          StopParticleFxLooped(brakedisc4, false);
          RemoveParticleFx(brakedisc4, true);
          delete brakedisc4;
        } else if(brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))] != null) {
          if(brakediscs[closeVehicle] == null) {
            if(GetVehicleWheelBrakePressure(closeVehicle, 1) > 0.0 && GetEntitySpeed(closeVehicle) > 0.0) {
              brakediscs[closeVehicle] = {front: 2, rear: 1};
            }
          } else {
            if(GetVehicleWheelBrakePressure(closeVehicle, 1) > 0.0 && GetEntitySpeed(closeVehicle) > 0.0) {
              if(IsVehicleInBurnout(closeVehicle)) {
                if(brakediscs[closeVehicle]["front"] > 0) {
                  brakediscs[closeVehicle] = {front: brakediscs[closeVehicle]["front"] - 0.5, rear: brakediscs[closeVehicle]["rear"]};
                }
                if(brakediscs[closeVehicle]["rear"] < 400) {
                  brakediscs[closeVehicle] = {front: brakediscs[closeVehicle]["front"], rear: brakediscs[closeVehicle]["rear"] + 1};
                }
              } else {
                if(brakediscs[closeVehicle]["front"] < 800) {
                  brakediscs[closeVehicle] = {front: brakediscs[closeVehicle]["front"] + 2, rear: brakediscs[closeVehicle]["rear"]};
                }
                if(brakediscs[closeVehicle]["rear"] < 400) {
                  brakediscs[closeVehicle] = {front: brakediscs[closeVehicle]["front"], rear: brakediscs[closeVehicle]["rear"] + 1};
                }
              }
            } else {
              if(brakediscs[closeVehicle]["front"] > 0) {
                brakediscs[closeVehicle] = {front: brakediscs[closeVehicle]["front"] - 0.5, rear: brakediscs[closeVehicle]["rear"]};
              }
              if(brakediscs[closeVehicle]["rear"] > 0) {
                brakediscs[closeVehicle] = {front: brakediscs[closeVehicle]["front"], rear: brakediscs[closeVehicle]["rear"] - 0.5};
              }
            }
            if(brakediscs[closeVehicle]["front"] > 80) {
              UseParticleFxAssetNextCall("core");
              let brakedisc1 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["x"], 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_lf"), brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["s"], false, false, false);
              if(brakediscs[closeVehicle]["front"] < 400) {
                SetParticleFxLoopedAlpha(brakedisc1, (brakediscs[closeVehicle]["front"] - 80) / 400);
              }
              StopParticleFxLooped(brakedisc1, false);
              RemoveParticleFx(brakedisc1, true);
              delete brakedisc1;
              UseParticleFxAssetNextCall("core");
              let brakedisc2 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["x"], 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_rf"), brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["s"], false, false, false);
              if(brakediscs[closeVehicle]["front"] < 400) {
                SetParticleFxLoopedAlpha(brakedisc2, (brakediscs[closeVehicle]["front"] - 80) / 400);
              }
              StopParticleFxLooped(brakedisc2, false);
              RemoveParticleFx(brakedisc2, true);
              delete brakedisc2;
            }
            if(brakediscs[closeVehicle]["rear"] > 80) {
              UseParticleFxAssetNextCall("core");
              let brakedisc3 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["x"], 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_lr"), brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["s"], false, false, false);
              if(brakediscs[closeVehicle]["rear"] < 200) {
                SetParticleFxLoopedAlpha(brakedisc3, (brakediscs[closeVehicle]["rear"] - 80) / 200);
              }
              StopParticleFxLooped(brakedisc3, false);
              RemoveParticleFx(brakedisc3, true);
              delete brakedisc3;
              UseParticleFxAssetNextCall("core");
              let brakedisc4 = StartParticleFxLoopedOnEntityBone("veh_exhaust_afterburner", closeVehicle, brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["x"], 0.0, 0.0, 0.0, 0.0, 90.0, GetEntityBoneIndexByName(closeVehicle, "wheel_rr"), brakedisclocation[GetDisplayNameFromVehicleModel(GetEntityModel(closeVehicle))]["s"], false, false, false);
              if(brakediscs[closeVehicle]["rear"] < 200) {
                SetParticleFxLoopedAlpha(brakedisc4, (brakediscs[closeVehicle]["rear"] - 80) / 200);
              }
              StopParticleFxLooped(brakedisc4, false);
              RemoveParticleFx(brakedisc4, true);
              delete brakedisc4;
            }
          }
        }
      });
    });
  }
  if(enabled) {
    setTimeout(discs, 3);
  }
}
discs();

function closeVehicles(callback) {
  let vehicles = [];
  let enumerator = FindFirstVehicle();
  if(DoesEntityExist(enumerator[1]) && GetPedInVehicleSeat(enumerator[1], -1) != null && !IsPedInAnyBoat(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnyHeli(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnySub(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnyPlane(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnyTrain(GetPedInVehicleSeat(enumerator[1], -1)) && GetVehicleEngineHealth(enumerator[1]) > -3000 && !IsEntityInWater(enumerator[1])) {
    vehicles.push(enumerator[1]);
  } else if(brakediscs[enumerator[1]] != null) {
    delete brakediscs[enumerator[1]];
  }
  let interval = setInterval(function() {
    let next = FindNextVehicle(enumerator[0]);
    if(next[0]) {
      if(DoesEntityExist(next[1]) && GetPedInVehicleSeat(next[1], -1) != null && !IsPedInAnyBoat(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnyHeli(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnySub(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnyPlane(GetPedInVehicleSeat(enumerator[1], -1)) && !IsPedInAnyTrain(GetPedInVehicleSeat(enumerator[1], -1)) && GetVehicleEngineHealth(enumerator[1]) > -3000 && !IsEntityInWater(enumerator[1])) {
        vehicles.push(next[1]);
      } else if(brakediscs[enumerator[1]] != null) {
        delete brakediscs[enumerator[1]];
      }
    } else {
      clearInterval(interval);
      delete interval;
      EndFindVehicle(enumerator[0]);
      delete enumerator;
      callback(vehicles);
    }
    delete next;
  }, 1);
}